<?php
/**
 * The main template file
 *
 * This is the most generic template file in a WordPress theme
 * and one of the two required files for a theme (the other being style.css).
 * It is used to display a page when nothing more specific matches a query.
 * E.g., it puts together the home page when no home.php file exists.
 *
 * @link https://codex.wordpress.org/Template_Hierarchy
 *
 * @package WordPress
 * @subpackage Biuro
 * @since 1.0
 * @version 1.0
 */

get_header('job'); ?>

            <div class="biuro-header">
                <div class="logo">
                    <a href="<?php echo pll_home_url(); ?>" title="<?php echo get_the_title( get_option('page_on_front') ); ?>">
                        <svg width="133px" height="78px">
                            <use xlink:href="#biuro-logo"></use>
                        </svg>
                    </a>
                </div><!-- .logo -->
                <p>BIURO - padedame, kai labiausiai reikia. Paprastas ir greitas laikinasis įdarbinimas.</p>
            </div><!-- .biuro-header -->

<?php
            while ( have_posts() ) :
?>
            <div class="biuro-title">
                <h1><span><?php the_title(); ?></span></h1>
            </div><!-- .biuro-title -->

<?php
                the_post();
                the_content();

            endwhile;
?>

<?php get_footer('job');
